function [Xv,Xh] = shrink_fro(Bv,Bh,tau)
% shrinkage operator that solves pointwisely
% minimize_X tau*|X|_fro + (1/2) * |X-B|^2
% where |X|_* is the Frobenius norm of X

% compute and shrink magnitude as scaling
mag = sqrt(sum(cat(3, abs(Bv).^2, abs(Bh).^2), 3));
mag = max(0, mag-tau) ./ (mag + 1e-12);

% scale input
nimg = size(Bv,3);
Xv = Bv.*repmat(mag,1,1,nimg);
Xh = Bh.*repmat(mag,1,1,nimg);